if ("undefined" == typeof(SemanticLinkSensor)) { 
var SemanticLinkSensor = function() {
var ActualTextElem;
var indnextdiv;
var pageextract;
var source;
var provider;
var MultiTab;

function getContentByDivClass (DivClass, endmark)
{
    if (DivClass.charAt(0) == '\"'  ||  DivClass.charAt(0) == '\'')
        DivClass = DivClass.substring(1, DivClass.length - 1);

    var tempArray = getElementsByClassName(DivClass, 'div');
    if (tempArray.length > 0)
    {
	    ActualTextElem = tempArray[0];
	    var fullpagestr = ActualTextElem.innerHTML;
	    pageextract = fullpagestr;
	    if (endmark)
	    {
	        indnextdiv = fullpagestr.indexOf(endmark);
	        if (indnextdiv > -1)
		        pageextract = fullpagestr.substring(0, indnextdiv);
        }
    }
}

function getContentByDivId (DivId, endmark)
{
    if (DivId.charAt(0) == '\"')
        DivId = DivId.substring(1, DivId.length - 1);

    ActualTextElem = window.content.document.getElementById(DivId);
    if (ActualTextElem)
    {
	    var fullpagestr = ActualTextElem.innerHTML;
	    pageextract = fullpagestr;
	    if (endmark)
	    {
	        indnextdiv = fullpagestr.indexOf(endmark);
	        if (indnextdiv > -1)
		        pageextract = fullpagestr.substring(0, indnextdiv);
        }
    }
}

var xmlhttp;
function loadXMLDoc (url)
{
xmlhttp=null;
if (window.XMLHttpRequest)
  {// code for all new browsers
  xmlhttp=new XMLHttpRequest();
  }
else if (window.ActiveXObject)
  {// code for IE5 and IE6
  xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
  }
if (xmlhttp!=null)
  {
  xmlhttp.onreadystatechange=state_Change;
  xmlhttp.open("GET",url,true);
  xmlhttp.send(null);
  }
else
  {
  alert("Your browser does not support XMLHTTP.");
  }
}

function state_Change ()
{
if (xmlhttp.readyState==4)
  {// 4 = "loaded"
  if (xmlhttp.status==200)
    {// 200 = OK
	processResults(xmlhttp.responseText);
    }
  else
    {
    alert(xmlhttp.status);
    }
  }
}
 
function processResults (ListOfConcepts)
{
//alert(ListOfConcepts);
    if (ListOfConcepts == null  ||  ListOfConcepts == "")
        return;

	if (ListOfConcepts.indexOf("Authentication failed") >= 0)
	{
		alert("Your access credentials have expired - please download the latest version from www.LinkSensor.com.");
		return;
	}

	var indconstart = ListOfConcepts.indexOf('/\">') + 3;
	if (indconstart == -1)
		indconstart = 0;
	var indconnext;
	var curcon;
	var bMarked;
	var MAX_CONCEPTS = 3;
	var totalMarked = 0;
	var ArCon = new Array();
	var j=0;
	for (var i=0; i < MAX_CONCEPTS; i++)
	{
		indconnext = ListOfConcepts.indexOf(":", indconstart);
		if (indconnext == -1)
			break;
		curcon = ListOfConcepts.substring(indconstart, indconnext);
		ArCon[j] = curcon;
		j++;
		indconstart = indconnext + 3;
	}

    ArCon.sort(function(a,b){return b.length - a.length});
	for (i=0; i < ArCon.length  &&  totalMarked < MAX_CONCEPTS; i++)
	{
		bMarked = markConcept(ArCon[i]);
		if (bMarked)
		    totalMarked++;
    }
} 

function markConcept (concept)
    {
        var bMarked = false;
	    var indconnext;
	    var condition = new RegExp("[ (/>)\\(\\r\\n\\t]" + concept + "[ \\.,;:!\\?\\)\\r\\n\\t]", "gi");
        var myArray;
        while ((myArray = condition.exec(ActualTextElem.innerHTML)) != null)	{	// TODO: need to allow br or p in front, or crlf
		    indconnext = myArray.index;
		    // check if not inside an <a tag
		    var indAtag = ActualTextElem.innerHTML.lastIndexOf('<a ', indconnext);
		    if (indAtag == -1)
		        indAtag = ActualTextElem.innerHTML.lastIndexOf('<A ', indconnext);
		    if (indAtag >= 0)
		    {
		        var indClosetag = ActualTextElem.innerHTML.lastIndexOf('</a>', indconnext);
		        if (indClosetag == -1)
		            indClosetag = ActualTextElem.innerHTML.lastIndexOf('</A>', indconnext);
		        if (indClosetag == -1  ||  indClosetag < indAtag)
                {
                    condition.lastIndex = indconnext + 1 + concept.length;
                    continue;
                }
		    }    
		    indAtag = ActualTextElem.innerHTML.lastIndexOf('<img', indconnext);
		    if (indAtag >= 0)
		    {
		        var indClosetag = ActualTextElem.innerHTML.lastIndexOf('>', indconnext);
		        if (indClosetag == -1  ||  indClosetag < indAtag)
                {
                    condition.lastIndex = indconnext + 1 + concept.length;
                    continue;
                }
		    }    
		    prelength = ActualTextElem.innerHTML.length;
		    turnIntoLink(ActualTextElem.innerHTML.substring(indconnext+1, indconnext+1 + concept.length), indconnext+1);
		    bMarked = true;
		    condition.lastIndex += ActualTextElem.innerHTML.length - prelength;
	    }
	    return bMarked;
    }

//CD6F6F
var prehtml = '<a style=\"text-decoration: none; color: #CD6F6F; border-bottom: 3px double;\" href=\"#\" onmouseover=\"whiteBalloon = new Balloon; whiteBalloon.showTooltip(event,\'';

var prehtml2; //= (MultiTab==true) ? '<iframe width=450 height=160 src=' : '<iframe width=350 height=140 src=';

var midhtml = '></iframe>';

var midhtml2;   // = (MultiTab==true) ? '\',1,450)\">' : '\',1,350)\">';

var posthtml = '</a>';

function turnIntoLink (concept, indconnext)
{
	var editedtext = ActualTextElem.innerHTML.substring(0, indconnext) +
				prehtml +
				prehtml2 +
				(MultiTab==false ? escape('\"http://www.sensebot.net/sensetabone.aspx?concept=') : escape('\"http://www.sensebot.net/sensetab.aspx?concept=')) + escape(concept) + escape('&provider=') + escape(provider) + escape('&story=') + escape(window.content.location.href) + escape('\"') + 
//				escape('\"http://www.sensebot.net/sensetab.aspx?concept=') + escape(concept) + escape('&provider=') + escape(provider) + escape('&story=') + escape(window.content.location.href) + escape('\"') + 
                midhtml +
                midhtml2 +
				concept + 
				posthtml +
				ActualTextElem.innerHTML.substring(indconnext + concept.length);
	ActualTextElem.innerHTML = editedtext;
}

function getElementsByClassName (className, tag, elm){

	var testClass = new RegExp("(^|\\s)" + className + "(\\s|$)");
	//var testClass = new RegExp(className + "[\\s]??");
	var tag = tag || "*";
	var elements = window.content.document.getElementsByTagName(tag);
	var returnElements = [];
	var current;
	var length = elements.length;
	for(var i=0; i<length; i++){
		current = elements[i];
		if(testClass.test(current.className)){
			returnElements.push(current);
		}	
	}

	return returnElements;
}


return {
sensebotInText : function (numtabs){

//alert("in");
if (numtabs == 0)
    MultiTab = false;
else
    MultiTab = true;
prehtml2 = (MultiTab==true) ? '<iframe width=485 height=150 src=' :
                                '<iframe width=360 height=130 src=';

midhtml2 = (MultiTab==true) ? '\',1,485)\">' :
                                '\',1,360)\">';

var headID = window.content.document.getElementsByTagName("head")[0];
var newScript = window.content.document.createElement('script');
newScript.type = 'text/javascript';
newScript.src = 'http://yui.yahooapis.com/2.3.0/build/yahoo-dom-event/yahoo-dom-event.js';
headID.appendChild(newScript);
newScript = window.content.document.createElement('script');
newScript.type = 'text/javascript';
newScript.src = 'http://www.sensebot.net/balloon.js';
headID.appendChild(newScript);
newScript = window.content.document.createElement('script');
newScript.type = 'text/javascript';
newScript.src = (MultiTab==true) ? 'http://www.sensebot.net/processresultsTabs.js' :
'http://www.sensebot.net/processresults.js';
headID.appendChild(newScript);

var arStart = new Array(
'class=\"entries\"',
'class=\"entry_body_post\"',
'class=\"entry_body_text\"',
'class=\"entry-body\"',
// WP:
'class=\"entry\"',
// Blogger:         
'class=\'post-body entry-content\'',
'class=\"post-body\"',
// Other:
'class=\"postBody\"',
'class=\"article\"',
'class=\"storycontent\"',
'class=\"postcontent\"',
'class=\"post\"',
'class=\"asset-body\"',
'class=\"blogContent\"',

'id=\"article\"',
'id=\"content\"'
);
/*
var arStart = new Array(
// Blogger:         
'class=\'post-body entry-content',
'class=\"post-body',
// WP:
'class=\"entry',
// Other:
'class=\"postBody',
'class=\"article',
'class=\"storycontent',
'class=\'story',
'class=\"post',
'class=\"asset-body',
'class=\"entries',

'id=\"article\"',
'id=\"content\"'
);
*/
var arEnd = new Array(
null,
null,
null,
null,
null,
null,
null,
null,
null,
null,
null,
null,
null,
null,
null,
null
);

var arProvider = new Array(
"Blogger", 
"Blogger",
"WordPress"
);

pageextract = "";
source = "";
provider = "";

for (j=0; j < arStart.length; j++)
{
    if (arStart[j].substring(0, 5) == 'class')
        getContentByDivClass(arStart[j].substring(6), arEnd[j]);
    else if (arStart[j].substring(0, 2) == 'id')
        getContentByDivId(arStart[j].substring(3), arEnd[j]);
    else
        continue;
    
    if (pageextract != "")
    {
        source = arStart[j];
        provider = "Related articles";  //  arProvider[j];
        break;
    }
}

//alert(pageextract);
if (pageextract == "")
{
	    // get <body>
	    var elements = window.content.document.getElementsByTagName('body');
		var length = elements.length;
	    //alert(length);
		if (length == 0)
		    return;
		ActualTextElem = elements[0];
        pageextract = ActualTextElem.innerHTML;
        //alert(pageextract);
        source = "body";
}
/*		    
if (pageextract == "")
{
    var tempArray = getElementsByTagName('html');
    if (tempArray.length > 0)
    {
        var elbody = tempArray[0];
        if (elbody.innerHTML.indexOf('class=') == -1)
            source = "";
        else
	        return;
	}
    else
        return;
}	
*/
//	alert(pageextract);

var numconcepts = 3;

//alert(sensebotUrl);
//loadXMLDoc(sensebotUrl);
//return;

var sbUrl = 'http://www.sensebot.net/extconcone.aspx?' + 'userName=extension' + '&numConcepts=' + numconcepts + '&artClass=' + source + '&artLength=' + pageextract.length
+ '&allURLs=' + escape(window.content.location.href) + '&prefix=' + ((MultiTab==true) ? 'SemanticLinkSensorTabs.' : 'SemanticLinkSensor.');

//alert(sbUrl);
if ("undefined" == typeof(JSONscriptRequest))
  //alert('!?');
    return;

  var obj=new JSONscriptRequest(sbUrl);
//alert('obj=' + obj);
  if (obj == null)
  {
//  alert('null');
    return;
    }
//alert('pre build');    
  obj.buildScriptTag();
//alert('pre script');    
  obj.addScriptTag();



return; 
}
};


} ();

// jsr_class.js
//
// JSONscriptRequest -- a simple class for making HTTP requests
// using dynamically generated script tags and JSON
//
// Author: Jason Levitt
// Date: December 7th, 2005
//
// A SECURITY WARNING FROM DOUGLAS CROCKFORD:
// "The dynamic <script> tag hack suffers from a problem. It allows a page 
// to access data from any server in the web, which is really useful. 
// Unfortunately, the data is returned in the form of a script. That script 
// can deliver the data, but it runs with the same authority as scripts on 
// the base page, so it is able to steal cookies or misuse the authorization 
// of the user with the server. A rogue script can do destructive things to 
// the relationship between the user and the base server."
//
// So, be extremely cautious in your use of this script.
//
//
// Sample Usage:
//
// <script type="text/javascript" src="jsr_class.js"></script>
// 
// function callbackfunc(jsonData) {
//      alert('Latitude = ' + jsonData.ResultSet.Result[0].Latitude + 
//            '  Longitude = ' + jsonData.ResultSet.Result[0].Longitude);
//      aObj.removeScriptTag();
// }
//
// request = 'http://api.local.yahoo.com/MapsService/V1/geocode?appid=YahooDemo&
//            output=json&callback=callbackfunc&location=78704';
// aObj = new JSONscriptRequest(request);
// aObj.buildScriptTag();
// aObj.addScriptTag();
//
//


// Constructor -- pass a REST request URL to the constructor
//
function JSONscriptRequest(fullUrl) {
    // REST request path
    this.fullUrl = fullUrl; 
    // Keep IE from caching requests
    this.noCacheIE = '&noCacheIE=' + (new Date()).getTime();
    // Get the DOM location to put the script tag
    this.headLoc = window.content.document.getElementsByTagName("head").item(0);
    //alert('head: ' + this.headLoc);
    // Generate a unique script tag id
    this.scriptId = 'JscriptId' + JSONscriptRequest.scriptCounter++;
}

// Static script ID counter
JSONscriptRequest.scriptCounter = 1;

// buildScriptTag method
//
JSONscriptRequest.prototype.buildScriptTag = function () {
//alert('in build');
    // Create the script tag
    this.scriptObj = window.content.document.createElement("script");
    
    // Add script object attributes
    this.scriptObj.setAttribute("type", "text/javascript");
    this.scriptObj.setAttribute("charset", "utf-8");
    this.scriptObj.setAttribute("src", this.fullUrl + this.noCacheIE);
    this.scriptObj.setAttribute("id", this.scriptId);
//alert('out build');
}
 
// removeScriptTag method
// 
JSONscriptRequest.prototype.removeScriptTag = function () {
    // Destroy the script tag
    this.headLoc.removeChild(this.scriptObj);  
}

// addScriptTag method
//
JSONscriptRequest.prototype.addScriptTag = function () {
    // Create the script tag
    //alert('!');
    this.headLoc.appendChild(this.scriptObj);
}
}